# WARNING - Generated by {fusen} from dev/flat_full.Rmd: do not edit by hand


# Test pour la fonction isValidEval_report
test_that("isValidEval_report returns TRUE for a valid eval_report object", {
  
  eval_report_obj <- list(
  data = list(
    modelparams = data.frame(a = 1:5, b = letters[1:5]),
    modeldispersion = data.frame(x = runif(10), y = rnorm(10))
  ),
  performances = list(
    aggregate = data.frame(x = runif(10), y = rnorm(10)),
    byparams = data.frame(param = 1:10, x = runif(10), y = rnorm(10))
  ),
  identity = list(
    params = ggplot2::qplot(x = rnorm(100)),
    dispersion = ggplot2::qplot(y = runif(100))
  ),
  precision_recall = list(
    params = ggplot2::qplot(x = runif(100)),
    aggregate = ggplot2::qplot(y = rnorm(100))
  ),
  roc = list(
    params = ggplot2::qplot(x = rnorm(100)),
    aggregate = ggplot2::qplot(y = runif(100))
  ),
  counts = ggplot2::qplot(x = rnorm(100))
)
  ################## -- TESTS
  expect_true(isValidEval_report(eval_report_obj))
})

# Test pour la fonction export_dataframe
test_that("export_dataframe writes dataframe to file without errors", {
  dataframe <- data.frame(x = 1:10, y = rnorm(10))
  outfile <- tempfile()
  export_dataframe(dataframe, outfile)
  expect_true(file.exists(outfile))
})

# Test pour la fonction export_eval_plots
test_that("export_eval_plots writes evaluation plots to files without errors", {
  
  eval_report_obj <- list(
  data = list(
    modelparams = data.frame(a = 1:5, b = letters[1:5]),
    modeldispersion = data.frame(x = runif(10), y = rnorm(10))
  ),
  performances = list(
    aggregate = data.frame(x = runif(10), y = rnorm(10)),
    byparams = data.frame(param = 1:10, x = runif(10), y = rnorm(10))
  ),
  identity = list(
    params = ggplot2::qplot(x = rnorm(100)),
    dispersion = ggplot2::qplot(y = runif(100))
  ),
  precision_recall = list(
    params = ggplot2::qplot(x = runif(100)),
    aggregate = ggplot2::qplot(y = rnorm(100))
  ),
  roc = list(
    params = ggplot2::qplot(x = rnorm(100)),
    aggregate = ggplot2::qplot(y = runif(100))
  ),
  counts = ggplot2::qplot(x = rnorm(100))
)
  
  ############################# -- TEST ###############"
  outfolder <- tempdir()
  setwd(outfolder)
  export_eval_plots(eval_report_obj, "png")
  expect_true(file.exists(file.path(outfolder, "plots/identity_modelparams.png")))
  expect_true(file.exists(file.path(outfolder, "plots/identity_modeldispersion.png")))
  expect_true(file.exists(file.path(outfolder, "plots/precision_recall_byparams.png")))
  expect_true(file.exists(file.path(outfolder, "plots/precision_recall_aggregated.png")))
  expect_true(file.exists(file.path(outfolder, "plots/roc_byparams.png")))
  expect_true(file.exists(file.path(outfolder, "plots/roc_aggregated.png")))
  expect_true(file.exists(file.path(outfolder, "plots/genes_expression.png")))
})


# Test pour la fonction export_evaluation_report
test_that("export_evaluation_report exports evaluation report to folder without errors", {
  outfolder <- tempdir()
  eval_report <- list(
    data = list(
      modelparams = data.frame(a = 1:5, b = letters[1:5]),
      modeldispersion = data.frame(x = runif(10), y = rnorm(10))
    ),
    performances = list(
      aggregate = data.frame(x = runif(10), y = rnorm(10)),
      byparams = data.frame(param = 1:10, x = runif(10), y = rnorm(10))
    ),
    identity = list(
      params = ggplot2::qplot(x = rnorm(100)),
      dispersion = ggplot2::qplot(y = runif(100))
    ),
    precision_recall = list(
      params = ggplot2::qplot(x = runif(100)),
      aggregate = ggplot2::qplot(y = rnorm(100))
    ),
    roc = list(
      params = ggplot2::qplot(x = rnorm(100)),
      aggregate = ggplot2::qplot(y = runif(100))
    ),
    counts = ggplot2::qplot(x = rnorm(100))
  )
  suppressWarnings(export_evaluation_report(eval_report, outfolder, plot_format = "png", width = 20))
  expect_true(file.exists(file.path(outfolder, "data_modelparams.tsv")))
  expect_true(file.exists(file.path(outfolder, "data_modeldispersion.tsv")))
  expect_true(file.exists(file.path(outfolder, "performances_aggregated.tsv")))
  expect_true(file.exists(file.path(outfolder, "performances_byparams.tsv")))
  expect_true(file.exists(file.path(outfolder, "plots", "identity_modelparams.png")))
  expect_true(file.exists(file.path(outfolder, "plots", "identity_modeldispersion.png")))
  expect_true(file.exists(file.path(outfolder, "plots", "precision_recall_byparams.png")))
  expect_true(file.exists(file.path(outfolder, "plots", "precision_recall_aggregated.png")))
  expect_true(file.exists(file.path(outfolder, "plots", "roc_byparams.png")))
  expect_true(file.exists(file.path(outfolder, "plots", "roc_aggregated.png")))
  expect_true(file.exists(file.path(outfolder, "plots", "genes_expression.png")))
})


