# WARNING - Generated by {fusen} from dev/flat_full.Rmd: do not edit by hand




# Test case 1: Check if the function returns a data frame
test_that("compute_rmse returns a data frame", {
  data <- data.frame(from = c("A", "A", "A", "A"),
                    description = c("X", "Y", "X", "Y"),
                    actual = c(1, 2, 3, 4),
                    estimate = c(10, 20, 30, 40))
  df_rmse <- compute_rmse(data, grouping_by = c("from", "description"))
  expect_s3_class(df_rmse, "data.frame")
  expect_equal(df_rmse$from, c("A", "A"))
  expect_equal(df_rmse$description, c("X", "Y"))
  expect_equal(df_rmse$RMSE, c(20.12461, 28.46050), tolerance = 1e-3)
  
  
  ## -- exact match 
  data <- data.frame(from = c("A", "A", "A", "A"),
                    description = c("X", "Y", "X", "Y"),
                    actual = c(1, 2, 3, 4),
                    estimate = c(1, 2, 3, 4))
  df_rmse <- compute_rmse(data, grouping_by = c("from", "description"))
  expect_s3_class(df_rmse, "data.frame")
  expect_equal(df_rmse$from, c("A", "A"))
  expect_equal(df_rmse$description, c("X", "Y"))
  expect_equal(df_rmse$RMSE, c(0, 0), tolerance = 0)

})



test_that("RMSE function calculates correct RMSE values", {
  # Test case 1: Same vectors
  y1 <- c(1, 2, 3, 4, 5)
  y_hat1 <- c(1, 2, 3, 4, 5)
  expect_equal(rmse(y1, y_hat1), 0, 
               info = "RMSE between identical vectors should be 0.")
  
  # Test case 2: Different vectors
  y2 <- c(1, 2, 3, 4, 5)
  y_hat2 <- c(2, 3, 4, 5, 6)
  expect_equal(round(rmse(y2, y_hat2), 2), 1, 
               info = "RMSE between different vectors should be approximately 1")
  
  # Test case 3: vector with NA
  y3 <- c(1, 2, 3, 4)
  y_hat3 <- c(1, 2, NA, 4)
  expect_equal(rmse(y3, y_hat3), 0)
  
  # Test case 4: Vectors with different lengths
  y4 <- c(1, 2, 3, 4, 5)
  y_hat4 <- c(1, 2, 3, 4)
  expect_error(rmse(y4, y_hat4), 
               info = "RMSE should throw an error for vectors with different lengths.")
})



