# WARNING - Generated by {fusen} from dev/flat_full.Rmd: do not edit by hand


# Test for is_dispersionMatrixValid
test_that("is_dispersionMatrixValid returns TRUE for valid dimensions", {
  matx_dispersion <- matrix(1:6, nrow = 2, ncol = 3)
  matx_bool_replication <- matrix(TRUE, nrow = 2, ncol = 3)
  expect_true(is_dispersionMatrixValid(matx_dispersion, matx_bool_replication))
})

test_that("is_dispersionMatrixValid throws an error for invalid dimensions", {
  matx_dispersion <- matrix(1:4, nrow = 2, ncol = 2)
  matx_bool_replication <- matrix(TRUE, nrow = 2, ncol = 3)
  expect_false(is_dispersionMatrixValid(matx_dispersion, matx_bool_replication))
})

# Test for generateCountTable
test_that("generateCountTable generates count table with correct dimensions", {
  mu_ij_matx_rep <- matrix(1:6, nrow = 2, ncol = 3)
  matx_dispersion_rep <- matrix(1:6, nrow = 2, ncol = 3)
  count_table <- generateCountTable(mu_ij_matx_rep, matx_dispersion_rep)
  expect_equal(dim(count_table), c(2, 3))
})



test_that("checkFractionofZero issues a warning for high fraction of zeros/ones", {
  # Test case 1: Less than 50% zeros and ones
  counts_table_1 <- matrix(c(0, 1, 2, 0, 0, 0, 0, 1, 1), ncol = 3)
  expect_message(checkFractionOfZero(counts_table_1), "50% of the counts simulated are bellow 1. Consider reviewing your input parameters.")
  
  # Test case 2: More than 50% zeros and ones
  counts_table_2 <- matrix(c(0, 1, 0, 0, 1, 10, 100, 1, 1), ncol = 3)
  expect_null(checkFractionOfZero(counts_table_2))
  
})


# Test for replicateMatrix
test_that("replicateMatrix replicates matrix correctly", {
  matrix <- matrix(1:9, nrow = 3, ncol = 3)
  replication_matrix <- matrix(TRUE, nrow = 3, ncol = 3)
  replicated_matrix <- replicateMatrix(matrix, replication_matrix)
  expect_equal(dim(replicated_matrix), c(3, 9))
})

# Test for warning_too_low_mu_ij_row function
test_that("warning_too_low_mu_ij_row emits warning for low mu_ij values", {
  # Create a sample mu_ij matrix
  mu_ij_matrix <- matrix(c(0.5, 0.7, 1.2, 0.2, 0.9, 1.1), nrow = 2)
  # Verify if warning message is emitted
  expect_message(warning_too_low_mu_ij_row(mu_ij_matrix, 2))
})


# Test for generateReplicationMatrix
test_that("generateReplicationMatrix generates replication matrix correctly", {
  replication_matrix <- generateReplicationMatrix(init_variable(),min_replicates = 2, max_replicates = 4)
  expect_equal(dim(replication_matrix), c(4, 2))
})

